let NPM_JS = "https://registry.npmjs.org";

export default {
	async fetch(request, env, ctx) {
		const url = new URL(request.url);
		// console.log('url :>> ', url);

		let origin = url.origin;

		// registry=http://localhost:8787/_debug
		if (url.pathname.startsWith('/_debug')) {
			url.pathname = url.pathname.replace('/_debug', '');
			NPM_JS = "https://registry.npmmirror.com";
			origin = `http://localhost:8787/_debug`;
		}

		if ("/" === url.pathname) {
			return new Response(`Hello ${url.origin} 'pnpm config set registry ${url.origin}' `);
		}
		if ("GET" !== request.method) {
			return new Response('Method not allowed', { status: 405, });
		}

		if (url.pathname.endsWith(".tgz")) {
			return fetch(`${NPM_JS}${url.pathname}`);
		}

		console.log('url.pathname :>> ', url.pathname); // >> /@vue%2Fbabel-plugin-jsx
		// https://registry.npmjs.org/@vue%2Fbabel-plugin-jsx
		// https://registry.npmjs.org/@vue/babel-plugin-jsx/-/babel-plugin-jsx-1.0.0-rc.2.tgz

		let response = await fetch(`${NPM_JS}${url.pathname}`);
		let text = await response.text()
		text = text.replace(new RegExp(`${NPM_JS}(.*?).tgz`, 'g'), `${origin}$1.tgz`);
		// console.log('text :>> ', text);
		return new Response(text, response);

		return new Response(`This is a worker for ${url.origin}`, { status: 500, });
	},
};
